// Persistence of Vision Ray Tracer Scene Description File
// File: boat.pov
// Vers: 3.1g
// Desc: Exile
// Date: 20.01.02
// Auth: Florian Kastell


#declare Lamp=
union{
 difference{
  sphere{<0,0,0>,.2 pigment{color rgb .1}}
  union{
   sphere{<0,0,0>,.19 pigment{color rgb 1}finish{metallic 1 reflection 1 specular 1 brilliance .01}}
   box{<-.5,-.5,0><.5,.5,.5> pigment{color rgb 1}}
  }
 }
 difference{
  cylinder{<0,-.1,-.1>,<0,-.5,-.1>.05 pigment{color rgb .5}}
  sphere{<0,0,0>,.2 pigment{color rgb .1}}
 }
 //radio
 cylinder{<0,-.1,-1>,<0,-.5,-1>.05 pigment{color rgb .5}}
 cylinder{<0,0,-1>,<0,-.1,-1>.1 pigment{color rgb .5}}
 box{<-.8,0,-1.1><.8,.1,-.9> pigment{color rgb 1}}
 
 //side light
 cylinder{<0,-.1,0>,<0,.05,0>.05 pigment{color rgb .5} rotate z*-45 translate <.75,-.7,-.1>}
 cylinder{<0,-.1,0>,<0,.05,0>.05 pigment{color rgb .5} rotate z*45 translate <-.75,-.7,-.1>}
  
 //light on or off
 #if (Boat_Lights=on)
  light_source{<0,0,-.05> rgb 2 fade_distance 8 fade_power 2}
    sphere {<0,0,-.05>, .05 pigment{ rgbf <1,1,1,.8>}}
  light_source{<.78,-.6,-.1> rgb y*3 fade_distance .4 fade_power 10}
  cylinder{<0,-.1,0>,<0,.05,0>.05 pigment{color rgbf <0,1,0,.5>} translate <.78,-.6,-.1>}
  light_source{<-.78,-.6,-.1> rgb x*3 fade_distance .4 fade_power 10}
  cylinder{<0,-.1,0>,<0,.05,0>.05 pigment{color rgbf <1,0,0,.5>} translate <-.78,-.6,-.1>}
 #end

 #if (Boat_Lights=off)
  sphere {<0,0,-.05>, .05 pigment{ rgbf <1,1,1.1,.9>}}
  cylinder{<0,-.1,0>,<0,.05,0>.05 pigment{color rgbf <0,1,0,.8>} translate <.78,-.6,-.1>}
  cylinder{<0,-.1,0>,<0,.05,0>.05 pigment{color rgbf <1,0,0,.8>} translate <-.78,-.6,-.1>}
 #end
}


#declare Boat=
union{
 difference{
  difference{
   union{
    cylinder{<0,0,-2>,<0,0,2>, 1 scale <1,2,1>}
    sphere{<0,0,1.35>, 1 scale <1,2,1.5>}
    pigment{color rgb <.8,0,.05>}finish{ambient .9}
   }
   box{<-2,.3,-2.1><2,2,3.8> pigment{color rgb 1}}
  }
  union{
   box{<-.9,.1,-1.9><.9,.9,1.9> pigment{color rgb .2}}
   cylinder{<0,.1,1.9>,<0,2,1.9>, .9 scale <1,2,1> pigment{color rgb <0,0,.5>}}
  }
 }
 //cockpit
 difference{
  superellipsoid{<.15,.15> scale <.7,.7,1> translate <0,.55,-.5> pigment{color rgb <1,.95,.96>} finish{ambient .4}}
  box{<-.71,-.3,-.3>,<.71,.3,.3> pigment{color rgb <1,.95,.96>}translate <0,.8,-1> finish{ambient .4}}
 }
 box{<-.69,-.3,-.3>,<.69,.3,.3> pigment{color rgb z*1}translate <0,.8,-1> finish{reflection .1 ambient .1}}
 box{<-.5,-.3,-.3>,<.5,.3,.3> pigment{color rgb z*1}translate <0,.8,-1.2> finish{reflection .1 ambient .1}}
 //box{<-2,.3,-1><2,1,0> pigment{color rgb z*1}}
 //lamp
 object{Lamp translate <0,1.6,0>}
 //front radio
 cylinder{<0,0,0>,<0,.8,0>.05 pigment{color rgb 1} translate <0,0,3.5>}
 
 cylinder{<0,0,0>,<0,3.5,0>.08 pigment{color rgb .1} translate <0,0,2.2>}
 cylinder{<-1.5,3,0>,<1.5,3,0>.06 pigment{color rgb .1} translate <0,0,2.13>}
}